

/* 
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: ...
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY

#include "test_mat.h"
#include "resource_manager.h"
#include "material.h"
#include "model.h"
#include "primitive_model.h"
#include "light.h"
using namespace std;


/**
   \brief standard constructor
   \todo this constructor is not jet implemented - do it
*/
TestMat::TestMat () 
{
   this->setClassName ("TestMat");

   /*   this->model1 = (Model*)ResourceManager::getInstance()->load("cube", PRIM, RP_LEVEL);
	this->model2 = (Model*)ResourceManager::getInstance()->load("sphere", PRIM, RP_LEVEL);
	this->model3 = (Model*)ResourceManager::getInstance()->load("cylinder", PRIM, RP_LEVEL);
	this->model4 = (Model*)ResourceManager::getInstance()->load("cone", PRIM, RP_LEVEL);
   */
   this->model1 = new PrimitiveModel(SPHERE, 2, 50);
   this->model2 = new PrimitiveModel(CUBE);
   this->model3 = new PrimitiveModel(CONE, 1, 50);
   this->model4 = new PrimitiveModel(CYLINDER, 1, 50);
   this->mat1 = new Material();
   this->mat2 = new Material();
   this->mat3 = new Material();
   this->mat4 = new Material();
   
   this->enabled = false;
   illum = 0;
   shiny = 1.0;

}

void TestMat::changeIllum()
{
  illum++;
  
  if (illum >3)
    illum = 0;

  mat1->setIllum(illum);
}

void TestMat::raiseAmbient()
{
  this->ambient+=.1;
  if (this->ambient > 1)
    ambient = 0;
  mat1->setAmbient(ambient,ambient,ambient);
}

void TestMat::raiseShiny()
{
  this->shiny *= 2.0;
  if (this->shiny > 200)
    shiny = 2;
  printf("shiniess changed to %d\n", shiny);
  mat1->setShininess(shiny);
}

void TestMat::randColor()
{
  mat1->setDiffuse((float)random()/(float)RAND_MAX,(float)random()/(float)RAND_MAX,(float)random()/(float)RAND_MAX);
  mat1->setSpecular((float)random()/(float)RAND_MAX,(float)random()/(float)RAND_MAX,(float)random()/(float)RAND_MAX);
}

void TestMat::enableTexture()
{
  mat1->setDiffuseMap("../data/pictures/load_screen.jpg");
}

void TestMat::enable()
{
  if (!enabled)
    {
      this->enabled = true;
      
      LightManager* tmpLM = LightManager::getInstance();
      tmpLM->addLight();
      tmpLM->setPosition(-50, 5, -3);
      tmpLM->addLight();
      tmpLM->setPosition(50, -10, 5);
      glDisable(GL_LIGHT0);
      
    }
}

/**
   \brief standard deconstructor

*/
TestMat::~TestMat () 
{
  // delete what has to be deleted here
}


void TestMat::draw()
{
  if (this->enabled)
    {
      glPushMatrix();
      glTranslatef(0,-1,0);
      this->mat1->select();
      this->model1->draw();
      
      glTranslatef(0,0,2);
      //      this->mat2->select();
      this->model2->draw();
      
      glTranslatef(0,2,-2);
      //      this->mat3->select();
      this->model3->draw();
      
      glTranslatef(0,0,2);
      //      this->mat4->select();
      this->model4->draw();
      glPopMatrix();
    }
}
